//File: MergerEngine.h

#ifndef MergerEngine_h_
#define MergerEngine_h_

#include "CommonBlockClasses.h"

#include <map>
#include <set>
#include <string>
using std::set;
using std::map;
using std::string;

BlockRect GetBoundary(BlockRect & r, int dir);

BlockRect ShiftRect(BlockRect & r, int dir);

class MergerEngine {
private:
	map<BlockRect, string> rects;
	map< BlockRect, map<BlockRect, string>::iterator > boundary_to_rect;

	bool CanMergeRects(BlockRect & a, BlockRect & b);
	void RemoveRect(BlockRect & r);
	void AddRect(BlockRect & r, string & data);

public:
	void AddBlock(BlockPos & pos, string & data);
	
	int NumRects();
	
	map<BlockRect, string>::iterator GetRawData();
	map<BlockRect, string>::iterator GetRawDataEnd();
};

#endif
