//File: StringHelpers.cpp
//Purpose: Provide simple string functions

#ifndef StringHelpers_h_
#define StringHelpers_h_

#include <string>
#include <sstream>
#include <vector>
using std::string;
using std::vector;

bool IsDigit(char c);

template<class T>
string inline ToString(T & from) {
	std::ostringstream holder;
	holder << from;
	return holder.str();
}

bool IsNaturalNumber(const string & str, int & result);

bool IsInteger(const string & str, int & result);

bool IsNaturalNumberWithLeadingZeros(const string & str, int & result);

bool IsFloatingPoint(const string & str, float & result);

void ExtractStringsFromLine(const string & line, vector<string> & strs);

//Gets rid of all 13 and 10 characters from the string.
void RemoveNewLineCharacters(string & str);

bool StartsWith(string & str, string & substr);
bool EndsWith(string & str, string & substr);

#endif
