//Program: BlockCompiler

#include "CommonBlockClasses.h"
#include "StringHelpers.h"
#include "MergerEngine.h"

#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <string>
using std::string;
using std::cout;
using std::endl;
using std::vector;
using std::map;

bool GetLine(string & str) {
	std::string line;
	// bool value = std::getline(std::cin, line);
	std::getline(std::cin, line);
	// if( value == false ) return false;
	str = line;

	if( std::cin.eof() ) return false;
	return true;
};

void ArgumentComplain() {
	cout << "usage: block_compiler (-rb | -rr | -rm) [...]" << endl;
	exit(0);
}

void GetOptions(int argc, char ** argv, bool raw_blocks, bool raw_rects,
	bool raw_map, bool separate)
{
	int input_type = -1;
	for(int i = 1; i < argc; i++) {
		string arg = argv[i];
		if( arg == "-rb" ) {
			if( input_type != -1 ) ArgumentComplain();
			input_type = 0;
		} else if( arg == "-rr" ) {
			if( input_type != -1 ) ArgumentComplain();
			input_type == 1;
		} else if( arg == "-rm" ) {
			if( input_type != -1 ) ArgumentComplain();
			input_type == 2;
		}
	}
	if( input_type == -1 ) ArgumentComplain();
	raw_blocks = false;
	raw_rects = false;
	raw_map = false;
	if( input_type == 0 ) raw_blocks = true;
	if( input_type == 1 ) raw_rects = true;
	if( input_type == 1 ) raw_map = true;
}

int main(int argc, char ** argv) {
	//Should actually get options!!!

	map<BlockPos, int> blocks;

	string line;
	int line_num = 0;
	while( GetLine(line) ) {
		line_num ++;
		vector<string> strs;
		ExtractStringsFromLine(line, strs);
		if( strs.size() == 4 ) {
			int x, y, z, tex;
			if( IsInteger(strs[0], x) == false ||
				IsInteger(strs[1], y) == false ||
				IsInteger(strs[2], z) == false ||
				IsInteger(strs[3], tex) == false )
			{
				cout << "Syntax Error on line " << line_num << ": " << line << endl;
				exit(0);
			}
			BlockPos pos(x,y,z);
			blocks[pos] = tex;
		}
	}

	MergerEngine merge_engine;
	for(map<BlockPos, int>::iterator itr = blocks.begin(); itr != blocks.end(); itr++) {
	if( itr->second != 0 ) {
			BlockPos pos = itr->first;
			string data_str = ToString(itr->second);
			merge_engine.AddBlock(pos, data_str);
		}
	}

	map<BlockRect, string>::iterator raw_end = merge_engine.GetRawDataEnd();
	for(map<BlockRect, string>::iterator itr = merge_engine.GetRawData(); itr != raw_end; itr++) {
		BlockRect r = itr->first;
		cout << r.min.x << " " << r.min.y << " " << r.min.z << " ";
		cout << r.max.x << " " << r.max.y << " " << r.max.z << " " << itr->second << "\n";
	}
	return 0;
}
